{
    $Id: thread.pas,V 2.4 2001-09-05 15:09:33+02 mss Exp mss $
    This file is part of the Free Component Library (FCL)
    Copyright (c) 1999-2000 by Peter Vreman

    Linux TThread implementation

    See the file COPYING.FPC, included in this distribution,
    for details about the copyright.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

 **********************************************************************}

Const
  MsgDir                    = '/';
  MsgChar                   = char (ord('T') + $80);
  NextThreadID:     integer = 1;
  NextThreadHandle2:THandle = 1;
  FPThreadStacksize         = 16384;

function IsThisThreadFreed (ThisHandle, ThisHandle2: THandle) : boolean;  // running in the context of the Mainthread
var   hp  : PFPThreadRec;
begin
   hp := Application.Threads.Root;
   Result := true;
   while (hp <> NIL) and Result do begin
//                           writeln ('          *** hp (1) = ', inttohex(integer(hp),8), ' ***');
     Result := not ((hp^.Thread.FHandle2 = ThisHandle2) and (hp^.Thread.FHandle = ThisHandle));
//                           writeln ('          *** hp/Killed = ', inttohex(integer(hp),8), '/',Application.Threads,Killed, ' ***');
       hp := hp^.next;
//                           writeln ('          *** hp (2) = ', inttohex(integer(hp),8), ' ***');
   end;
end;


(*
function ThreadSelf:TThread;
var
  hp : PFPThreadRec;
  sp : longint;
begin
  sp:=SPtr;
  hp:=Application.Threads.Root;
  while assigned(hp) do
   begin
     if (sp<=hp^.Thread.FStackPointer) and
        (sp>(hp^.Thread.FStackPointer-hp^.Thread.FStackSize)) then
      begin
        Result:=hp^.Thread;
        exit;
      end;
     hp:=hp^.next;
   end;
  Result:=nil;
end;
*)

//function SIGCHLDHandler(Sig: longint): longint; cdecl;//this is std linux C declaration as function
procedure SIGCHLDHandler(Sig: longint); cdecl;         // running in the context of the Thread
begin
  waitpid(-1, nil, WNOHANG);
end;

procedure InitThreads;                    // running in the context of the Mainthread
var
  Act, OldAct: PSigActionRec;
//  i : integer;
  SemUn : TSemUn;
  Res: LongInt;
  Reb : boolean;
  FThreadInitException : TObject;
const oct666 =  438;
begin
  FThreadInitException := NIL;
  Application.Threads.Root          :=nil;
  Application.Threads.ThreadsInited :=true;

// This will install SIGCHLD signal handler
// signal() installs "one-shot" handler,
// so it is better to install and set up handler with sigaction()

  GetMem(Act, SizeOf(SigActionRec));
  GetMem(OldAct, SizeOf(SigActionRec));

  Act^.handler.sh := @SIGCHLDHandler;
  Act^.sa_flags := SA_NOCLDSTOP {or SA_NOMASK or SA_RESTART};
  Act^.sa_mask := 0; //Do not block all signals ??. Don't need if SA_NOMASK in flags

  SigAction(SIGCHLD, Act, OldAct);

  FreeMem(Act, SizeOf(SigActionRec));
  FreeMem(OldAct, SizeOf(SigActionRec));

  Application.Threads.MsgKey := ftok (MsgDir, MsgChar);

  Application.Threads.SemID := semget(Application.Threads.MsgKey,Application.FThreadsMax, IPC_CREAT or IPC_EXCL or oct666);     // create, must not exist
//     writeln ('          --- semget FPThreadMsgKey/Application.Threads.SemID/IPCError ' + inttohex(Application.Threads.MsgKey,8) + '/' + inttohex(Application.Threads.SemID,8) + '/' + sys_errlist[IPCError] + ' ***');
  if Application.Threads.SemID = -1 then begin
    Application.Threads.SemID := semget(Application.Threads.MsgKey,Application.FThreadsMax, oct666);     // attach
//       writeln ('          --- semget Application.Threads.MsgKey/Application.Threads.SemID/IPCError ' + inttohex(Application.Threads.MsgKey,8) + '/' + inttohex(Application.Threads.SemID,8) + '/' + sys_errlist[IPCError] + ' ***');
    res := semctl(Application.Threads.SemID, Application.FThreadsMax, IPC_RMID, SemUn);   // exists
//       writeln ('          --- semctl IPC_RMID res/IPCError ', res, '/', sys_errlist[IPCError] + ' ***');
    if res = -1 then begin
      raise (FThreadInitException);
//      halt;
    end;
    Application.Threads.SemID := semget (Application.Threads.MsgKey, Application.FThreadsMax, IPC_CREAT or oct666);     // create if notexist
//       writeln ('          --- semget Application.Threads.MsgKey/Application.Threads.SemID/IPCError ' + inttohex(Application.Threads.MsgKey,8) + '/' + inttohex(Application.Threads.SemID,8) + '/' + sys_errlist[IPCError] + ' ***');
    if Application.Threads.SemID = -1 then begin
      raise (FThreadInitException);
//      halt;
    end;
  end;
  Application.Threads.MsgID := msgget(Application.Threads.MsgKey, IPC_CREAT  or IPC_EXCL or oct666);     // create if notexist
//     writeln ('          --- msgget Application.Threads.MsgKey/Application.Threads.MsgID/IPCError ' + inttohex(Application.Threads.MsgKey,8) + '/' + inttohex(Application.Threads.MsgID,8) + '/' + sys_errlist[IPCError] + ' ***');
  if Application.Threads.MsgID = -1 then begin
    Application.Threads.MsgID := msgget(Application.Threads.MsgKey, oct666);     // attach
//       writeln ('          --- msgget Application.Threads.MsgKey/Application.Threads.MsgID/IPCError ' + inttohex(Application.Threads.MsgKey,8) + '/' + inttohex(Application.Threads.MsgID,8) + '/' + sys_errlist[IPCError] + ' ***');
    reb := msgctl(Application.Threads.MsgID, IPC_RMID, NIL);
//       writeln ('          --- msgctl IPC_RMID IPCError: ', sys_errlist[IPCError] + ' ***');
    if not reb then begin
      raise (FThreadInitException);
//      halt;
    end;
    Application.Threads.MsgID := msgget (Application.Threads.MsgKey, IPC_CREAT or oct666);     // create if notexist
//       writeln ('          --- msgget Application.Threads.MsgKey/Application.Threads.MsgID/IPCError ' + inttohex(Application.Threads.MsgKey,8) + '/' + inttohex(Application.Threads.MsgID,8) + '/' + sys_errlist[IPCError] + ' ***');
    if Application.Threads.MsgID = -1 then begin
      raise (FThreadInitException);
//      halt;
    end;
  end;
end;


procedure DoneThreads;                    // running in the context of the Mainthread
var
  SemUn : TSemUn;
//  Res: LongInt;
begin
  Application.Threads.ThreadsInited:=false;
  msgctl(Application.Threads.MsgID, IPC_RMID, NIL);
//     writeln ('          --- msgctl IPC_RMID IPCError ', sys_errlist[IPCError] + ' ***');
  {res:=} semctl(Application.Threads.SemID, Application.FThreadsMax, IPC_RMID, SemUn);
//     writeln ('          --- semctl IPC_RMID res/IPCError ', res, '/', sys_errlist[IPCError] + ' ***');
end;


procedure AddThread(t:TThread);           // running in the context of the Mainthread
var
  hp : PFPThreadRec;
  count : integer;
  FThreadInitException : TObject;
begin
  { Need to initialize threads ? }
  FThreadInitException := NIL;
  if not Application.Threads.ThreadsInited then
   InitThreads;

  count := 0;
  hp := Application.Threads.Root;
  while hp <> NIL do begin
     inc (count);
     hp := hp^.next;
  end;
  if count >= Application.FThreadsMax then begin
      raise (FThreadInitException);
//      writeln ('          ??? too much threads ???');
  end;

  { Put thread in the linked list }
  new(hp);
  hp^.Thread:=t;
  hp^.next:=Application.Threads.Root;
  Application.Threads.Root:=hp;
end;


procedure RemoveThread(t:TThread);        // running in the context of the Mainthread
var
  lasthp, hp : PFPThreadRec;
  FThreadRemoveException : TObject;
begin
//               writeln ('          *** remove thread ', t.FThreadID, ' Application.ThreadCount = ', Application.ThreadCount, ' ***');
  FThreadRemoveException := NIL;
  t.suspend;
  if (GetPID <> Application.Handle) then begin
     // not from Mainthread
     raise (FThreadRemoveException);
  end;
  hp:=Application.Threads.Root;
  lasthp := NIL;
  while (hp <> NIL) and (hp^.thread.ThreadID <> t.ThreadID) do begin
     lasthp := hp;
     hp := hp.next
  end;
//             writeln ('          *** Root/hp = ', inttohex(integer(Application.Threads.Root),8), '/', inttohex(integer(hp),8), ' ***');
  if hp <> NIL then begin
    if lasthp = NIL then begin
      Application.Threads.Root := hp^.next;
//             writeln ('          *** Application.Threads.Root = ', inttohex(integer(Application.Threads.Root),8), ' ***');
     end else begin
      lasthp^.next := hp^.next;
//             writeln ('          *** lasthp/next = ', inttohex(integer(lasthp),8), '/', inttohex(integer(hp^.next),8), ' ***');
    end;
    dispose (hp);
   end else begin
      // Thread not found
     raise (FThreadRemoveException);
  end;
  if Application.Threads.Root = NIL then DoneThreads;
end;


{ TThread }
function ThreadProc(args:pointer): Integer;cdecl;  // running in the context of the Thread
var
  Thread : TThread absolute args;
  const UNBLOGSIGC: Integer = 1 shl SIGKILL;
begin
  // in case this process is started before the main Thread could suspend it
  repeat until not Thread.Suspended;
  Thread.Execute;
//      writeln ('          *** Done Thread ID = ' + inttostr (Thread.FThreadID) + ' ***');
//  FreeThread := Thread.FFreeOnTerminate;
  Result := Thread.FReturnValue;
  SigProcMask (SIG_UNBLOCK, @UNBLOGSIGC, NIL);
//      writeln ('          *** TThread.DoTerminate  Thread ID = ' + inttostr (Thread.FThreadID) + ' ***');
  Thread.DoTerminate;
//      writeln ('          *** after TThread.DoTerminate  ***');
// kill thread
//            writeln ('          *** ExitProcess PIG/TID/PID/Result ' + inttostr(GetPID) + '/'+ inttostr(Thread.ThreadID) + '/'  + inttostr(Thread.Handle) + '/'+ inttostr(Result) + ' ***');
  Thread.FFinished := True;
  ExitProcess(Result);
end;


destructor TThread.Destroy;                     // running in the context of the Mainthread
begin
  Application.Threads.Freed := true;
//       writeln ('          *** TThread.Destroy ID/Handle/Finished/suspended ', ThreadID, '/', Handle, '/', FFinished, '/', FSuspended, ' ***');
  if not FFinished then begin
//        writeln ('          *** TThread.Destroy: Kill(', FHandle, ', SIGKILL) ***');
//  suspend;
    Kill(FHandle, SIGKILL);
  end;
  dec(FStackPointer,FStackSize);
  Freemem(pointer(FStackPointer),FStackSize);
  RemoveThread(self);
  inherited Destroy;
end;


procedure TThread.CallOnTerminate;        // running in the context of the Mainthread
var freeit: boolean;
    ThisHandle, ThisHandle2: THandle;
begin
//  kill thread
  ThisHandle  := FHandle;
  ThisHandle2 := FHandle2;
  freeit := FreeOnTerminate;    // FOnTerminate might free the thread
  if assigned (FOnTerminate) then FOnTerminate(Self); //might free the thread
//        writeln ('          *** after FOnTerminate ***');
  if freeit then begin
//        writeln ('          *** call TThread.Free ***');
    Free;
  end;
//        writeln ('          *** IsFreed ?  ***');
  if IsThisThreadFreed (ThisHandle, ThisHandle2) then begin  //the user or the code above might have freed the thread
//        writeln ('          *** TThread.CallOnTerminate: Kill(', FHandle, ', SIGKILL) ***');
    Kill(ThisHandle, SIGKILL);  // The Thread could not finish itself, the semaphore was not freed, becaus it had no stack any more
  end;
end;

procedure TThread.DoTerminate;            // running in the context of the Thread
begin
//      writeln ('          *** DoTerminate TID/PID ' + inttostr(ThreadID) + '/' + inttostr(FHandle) + ' ***');
    Synchronize(@CallOnTerminate);
end;


const
{ I Don't know idle or timecritical, value is also 20, so the largest other
  possibility is 19 (PFV) }

{ Timecritical:
  the sheduler policy should be changed to FIFO
  the appropriate system call is not yet implemented in FP}
  
  Priorities: array [TThreadPriority] of Integer =
//   (-20,-19,-10,9,10,19,20);  ??
  (-20,-15,-10,0,10,20,50);
procedure TThread.SetPriority(Value: TThreadPriority);  // running in any context
begin
  if Value <> FPriority then begin
    if Value <> tpTimeCritical then begin
//    only allowed when root user
//    set SchedulerFiFo and Realtime Priority  (Priorities[tpTimeCritical])
     end else begin
      if FPriority = tpTimeCritical then begin
//     set SchedulerNormal
      end;
      Linux.SetPriority(Prio_Process,FHandle, Priorities[Value]);
      FPriority := Value;
    end;
  end;
end;



procedure TThread.SetSuspended(Value: Boolean);         // running in any context
begin
  if Value <> FSuspended then
    if Value then
      Suspend
    else
      Resume;
end;


procedure TThread.Suspend;                              // running in any context
begin
  Kill(FHandle, SIGSTOP);
  FSuspended := true;
end;


procedure TThread.Resume;                               // running in any context
begin
    Kill(FHandle, SIGCONT);
    FSuspended := False;
end;


procedure TThread.Terminate;                             // running in any context
begin
  FTerminated := True;
end;

function TThread.WaitFor: Integer;                       // running in the context of the Mainthread
var
  status : longint;
begin
//        writeln ('          *** waitfor TID/handle ', FThreadID, '/', FHandle, ' ***');
  if not FFinished then begin
     WaitPid(FHandle,@status,0);
  end;   
  Result:=ReturnValue;
end;


constructor TThread.Create(CreateSuspended: Boolean);
var
  Flags: Integer;
  SemUn : TSemUn;
//  res: integer;
  hp, hpold : PFPThreadRec;
begin
//                 writeln ('          *** create thread ***');
  inherited Create;
  FPriority := tpNormal;
  FTerminated := false;
  AddThread(self);
  FSuspended := true;  //Thread is not allowed to start
  Flags := CLONE_VM + CLONE_FS + CLONE_FILES + CLONE_SIGHAND + SIGCHLD;
  { Setup 16k of stack }
  FStackSize:= FPThreadStackSize;
  Getmem(pointer(FStackPointer),FStackSize);
  inc(FStackPointer,FStackSize);
  FHandle2 := NextThreadHandle2;
  inc (NextThreadHandle2);
  FThreadID := 0;
  repeat
     FThreadID := NextThreadID;
     inc (NextThreadID);
//      writeln ('          *** Create Thread from PID ' + inttostr (GetPID) + ' ***');
//                writeln ('          *** NextThreadID ', NextThreadID, ' ***');
     if NextThreadID > Application.FThreadsMax then NextThreadID := 1;
     hp := Application.Threads.Root;
     repeat
//                writeln ('          *** hp ', inttohex(integer(hp),8), ' ***');
       if hp^.Thread.ThreadID = NextThreadID then hpold := NIL else hpold := hp;;
       hp := hp^.next;
     until (hp = NIL) or (hpold = NIL);
  until hpold <> NIL;
  FMethod := NIL;
  SemUn.val := 0;
  {res:=} semctl(Application.Threads.SemID, FThreadID, SETVAL, SemUn);
//     writeln ('          --- semctl SETVAL res/IPCError ', res, '/', sys_errlist[IPCError] + ' ***');

  { Clone }
//                writeln ('          *** cloning ***');
  FHandle:= Clone(@ThreadProc,pointer(FStackPointer),Flags,self);
//      writeln ('          *** ThreadID/PID/Handle2 = ' + inttostr (FThreadID) + '/' + inttostr (FHandle)  + '/' + inttostr (FHandle2) + ' ***');
  if CreateSuspended then suspend;  // the thread already might run in a loop with FSunspended = true
  Suspended := CreateSuspended;;
end;



procedure TThread.Synchronize(Method: TThreadMethod);
var
   msg : TFPThreadMessage;    //PMsgBuf;
   sem : TSemBuf;
   res : Boolean;
const msgflg = 0;
begin
  FSynchronizeException := nil;
  FMethod := Method;
//         writeln ('          *** SYNCHRONIZE: PID->TID/PID ' + inttostr (GetPID) + '->' + inttostr(FThreadID) + '/' + inttostr(FHandle) + '['+ inttohex(integer(self),8) + '.' + inttohex(integer(@FMethod),8) + '] ***');

    msg.MType := FPMsgSynchonize;
    msg.Sender:= self;
    res := msgsnd (Application.Threads.MsgID, @msg,    TFPThreadMessageSize, msgflg);
    if not res then begin
      raise (FSynchronizeException);
//       writeln ('          ??? Synchronize msgsnd IPCError: ', sys_errlist[IPCError], ' ???');
    end;

    sem.sem_num := FThreadID;
    sem.sem_op  := -1;
    sem.sem_flg := 0;
    res := semop  (Application.Threads.SemID, @sem, 1);    // dec and wait Semaphore
    if not res then begin
      raise (FSynchronizeException);
//       writeln ('          ??? Synchronize semop 1 IPCError: ', sys_errlist[IPCError], ' ???');
    end;
//         writeln ('          *** linuxerror ' + inttostr(linuxerror) + ' ***');
end;



{
  $Log: thread.pas,V $
  Revision 2.4  2001-09-05 15:09:33+02  mss
  <>

  Revision 2.3  2001-08-30 11:50:13+02  mss
  <>

  Revision 2.2  2001-08-28 14:55:21+02  mss
  <>

  Revision 2.1  2001-08-27 15:11:12+02  mss
  <>

    * Revision 2.0  2001-08-24 15:28:07+02  mss
    * Threads done via Application
    * first working version
  
  Revision 1.9  2000/05/17 18:31:18  peter
    * fixed for new sigactionrec

  Revision 1.8  2000/01/07 01:24:34  peter
    * updated copyright to 2000

  Revision 1.7  2000/01/06 01:20:33  peter
    * moved out of packages/ back to topdir

  Revision 1.1  2000/01/03 19:33:09  peter
    * moved to packages dir

  Revision 1.5  1999/10/27 10:40:30  peter
    * fixed threadproc decl

  Revision 1.4  1999/08/28 09:32:26  peter
    * readded header/log

  Revision 1.2  1999/05/31 12:47:59  peter
    * classes unit to unitobjects

  Revision 1.1  1999/05/30 10:46:42  peter
    * start of tthread for linux,win32

}

